﻿@model PurchaseOrderItemsFormView

@{
    string test = "";
    bool _View = ((UserView)Session["UserLogin"]).ListUserPageAction.Where(c => c.PageInternalKey == Enums.Pages.PurchaseOrder.ToDescriptionString() && c.InternalKey == Enums.Actions.View.ToDescriptionString()).FirstOrDefault() != null ? true : false;
}
<script type="text/javascript">
    var DistrRuleItems = [];
    var WhItems = [];
    var GLItems = [];
    $.ajax({
        url: '/Purchase/PurchaseOrder/_GetDistributionRuleList',
        type: 'POST',
        data: {},
        traditional: true,
        cache: false,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {

                DistrRuleItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });

            });
        }, error: function (xhr) {
            ErrorCalls(xhr.status)
            l
        },
    });

    $.ajax({
        url: '/Purchase/PurchaseOrder/_GetWarehouseList',
        type: 'POST',
        data: {},
        traditional: true,
        cache: false,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {
                WhItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });
            });
        }, error: function (xhr) {
            ErrorCalls(xhr.status)

        },
    });

    $.ajax({
        url: '/Purchase/PurchaseOrder/_GetGLAccountList',
        type: 'POST',
        data: { pPageKey: "@Model.PageKey" },
        traditional: true,
        cache: false,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {
                GLItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });
            });
        }, error: function (xhr) {
            ErrorCalls(xhr.status)

        },
    });
</script>

<div id="TableItemsForm">
    <table class="table table-striped PurchaseOrderTable">
        <thead>
            <tr>
                @*<th>&nbsp;</th>*@
                <th>&nbsp;</th>
                <th>&nbsp;</th>
                <th><strong>@PurchaseOrders.Item</strong></th>
                @if (Model.CkCatalogNum == true)
                {
                    <th><strong>@PurchaseOrders.BPCN</strong></th>
                }
                <th><strong>@PurchaseOrders.Description</strong></th>
                <th><strong>Wh</strong></th>
                <th>@PurchaseOrders.DR</th>
                <th>Stock</th>
                <th>@PurchaseOrders.GLA</th>
                <th>@PurchaseOrders.FT</th>
                <th>@PurchaseOrders.DelDate</th>
                <th><strong>@PurchaseOrders.Qty</strong></th>
                <th><strong>@PurchaseOrders.Currency</strong></th>
                <th><strong>@PurchaseOrders.Price</strong></th>
                <th><strong>Uom</strong></th>
                <th><strong>Discount %</strong></th>
                <th><strong>Price After Disc.</strong></th>
                <th><strong>Tax Code</strong></th>
                <th><strong>Tax %</strong></th>
                <th><strong>Gross Price</strong></th>
                <th><strong>Tax Amount</strong></th>
                @{
                    if (Model.Lines.Count > 0)
                    {
                        if (Model.Lines.FirstOrDefault().MappedUdf != null && Model.Lines.FirstOrDefault().MappedUdf.Count > 0)
                        {
                            foreach (var DictRow in Model.Lines.FirstOrDefault().MappedUdf.OrderBy(c => c.UDFName))
                            {
                                <th><strong>@DictRow.UDFDesc</strong></th>
                            }
                        }
                    }
                }
                <th><strong>Total (LC)</strong></th>
                <th><strong>Gross Total</strong></th>
            </tr>
        </thead>
        <tbody>
            @if (Model != null)
            {
                string mTAuto;
                string mTAutoDR;
                string mDescItem;
                string mTAutoGLAccount;
                string mFreeTxt;
                string mDelDate;
                string mTxtId;
                string mTdId;
                string mDpId;
                string mTxtCountId;
                string mTrId;
                string currencySelected;
                double mTotal = 0;
                string mUOMAuto;
                string mlistUOM;

                string mDiscPrcnt;
                string mTaxCode;
                string mVatPrcnt;
                string mPriceAfVAT;
                string mVatSum  ;
                string mGTotal;
                string mPriceDisc ;

                foreach (PurchaseOrderLineView item in Model.Lines)
                {
                    mTAuto = "AutoComplete" + item.LineNum;
                    mTAutoDR = "AutoCompleteDR" + item.LineNum;
                    mDescItem = "DescItem" + item.LineNum;
                    mTAutoGLAccount = "AutoCompleteGL" + item.LineNum;
                    mFreeTxt = "FreeTxt" + item.LineNum;
                    mDelDate = "DelDate" + item.LineNum;
                    mTxtId = "txt" + item.LineNum;
                    mTdId = "td" + item.LineNum;
                    mDpId = "dp" + item.LineNum;
                    mTxtCountId = "txtcount" + item.LineNum;
                    mTrId = "tr" + item.LineNum;
                    currencySelected = (!string.IsNullOrEmpty(item.Currency) ? item.Currency : Model.DocCur).ToString().Trim();
                    mTotal = 0;
                    mUOMAuto = "UOMAuto" + item.LineNum;
                    mlistUOM = "mlistUOM" + item.LineNum;

                    mDiscPrcnt = "DiscPrcnt" + item.LineNum;
                    mTaxCode = "TaxCode" + item.LineNum;
                    mVatPrcnt = "VatPrcnt" + item.LineNum;
                    mPriceAfVAT = "PriceAfVAT" + item.LineNum;
                    mVatSum = "VatSum" + item.LineNum;
                    mGTotal = "GTotal" + item.LineNum;
                    mPriceDisc = "Price" + item.LineNum;

                    if (item.RateGl == 0 || item.RateLine == 0)
                    {
                        <script type="text/javascript">
                            $('#alertRates').show();
                            $('#btnOk').attr("disabled", true);
                        </script>
                    }
                    else
                    {
                        mTotal = (((double)item.Price) / item.RateGl) * item.RateLine;
                        <script type="text/javascript">
                            $('#alertRates').hide();
                            $('#btnOk').attr("disabled", false);
                        </script>
                    }
                    <tr id='@mTrId'>
                        <td>
                            @if(item.LineStatus == "O")
                            {
                                <button onclick="DeleteRow('@item.LineNum')" type="button" class="btn btn-primary btn-xs"><span class="glyphicon glyphicon-trash"></span></button>   
                            }
                            <input type="hidden" id="@item.LineNum" value="@item.CalcTax" />
                            <input id="BaseType_@item.LineNum" value="@item.BaseType" style="display:none" />
                            <input id="BaseEntry_@item.LineNum" value="@item.BaseEntry" style="display:none" />
                            <input id="BaseLine_@item.LineNum" value="@item.BaseLine" style="display:none" />
                        </td>
                        <td>
                            @if (_View)
                            {
                                <a href='@Url.Action("ActionItemMaster", "MasterData", new {  Area = "MasterData",@pActionItemMaster = "View", @pItemCode = item.ItemCode })' class="btn btn-primary btn-xs" target="_blank">
                                    <span class="glyphicon glyphicon-eye-open"></span>
                                </a>
                            }
                        </td>
                        <td class="item_desc_table">@item.ItemCode</td>
                        @if (Model.CkCatalogNum == true)
                        {
                            <td><input class="form-control item_desc_table" value='@item.Substitute' disabled="disabled" /></td>
                        }
                        <td><input id='@mDescItem' class="form-control descDocuments" value='@item.Dscription' onchange="LineWasChanged('@item.LineNum');" /></td>
                        <td><input id='@mTAuto' name="whs" class="form-control autoComplete" value="@(Model.UsersSetting.DftWhs == null ? item.WhsCode : Model.UsersSetting.DftWhs)" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td><input id='@mTAutoDR' class="form-control autoComplete" value="@(item.OcrCode != null ? item.OcrCode : Model.UsersSetting.DftDistRule)" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td>
                            <a href='#'>
                                @if (item.hasStock)
                                {
                                    <span class="glyphicon glyphicon-ok" onclick="GetStock('@item.ItemCode')"></span>
                                }
                                else
                                {
                                    <span class="glyphicon glyphicon-remove" onclick="GetStock('@item.ItemCode')"></span>
                                }
                            </a>

                        </td>
                        <td><input id='@mTAutoGLAccount' class="form-control autoCompleteGLAccount" value="@(item.GLAccount != null ? item.GLAccount.FormatCode : "")" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td><input id='@mFreeTxt' class="form-control autoCompleteGLAccount" placeholder="@PurchaseOrders.FT" onchange="LineWasChanged('@item.LineNum');" value="@(item.FreeTxt)"></td>
                        <td>
                            <div class="input-group date dateDocuments">
                                <input value="@((item.ShipDate != null && item.ShipDate != DateTime.MinValue) ? item.ShipDate.ToString().AsDateTime().ToShortDateString() : "")" class="form-control valid" data-val="true" data-val-date=" must be a date." id="@mDelDate" name="@mDelDate" placeholder="@PurchaseOrders.DelDate" onchange="LineWasChanged('@item.LineNum');" type="text"><span class="input-group-addon"><i class="glyphicon glyphicon-calendar"></i></span>
                            </div>
                        </td>
                        <td><input type="number" id='@mTxtCountId' class="form-control quantityDocuments" value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Quantity, item.Quantity))' min="0" onchange="LineWasChanged('@item.LineNum'); ChangeValue('@item.LineNum',true); ChangeQuantityValue('@item.LineNum', '@Shared.NumberGreaterZero');" /></td>
                        <td>
                            @Html.DropDownList(mDpId, new SelectList(item.ListCurrency, "CurrCode", "CurrName", currencySelected), new { @Id = mDpId, @class = "form-control currencyDocuments", @onchange = "LineWasChanged('" + @item.LineNum + "'); ChangeValue('" + @item.LineNum + "',true)" })
                        </td>
                        <td><input onchange="LineWasChanged('@item.LineNum'); ChangeValue('@item.LineNum',true);" type="number" class="form-control priceDocuments" id='@mTxtId' value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, item.PriceBefDi))' /></td>
                        <td>
                            <input id="@mUOMAuto" list="@mlistUOM" value="@(item.UomCode != null ? item.UomCode : string.Empty)" onchange="LineWasChanged('@item.LineNum'); UpdateUOM('@item.LineNum');" class="form-control uomDocument">
                            <datalist id="@mlistUOM">
                                @if(item.UnitOfMeasureList != null)
                                { 
                                    foreach (UnitOfMeasure mUOMAux in item.UnitOfMeasureList)
                                    {
                                        <option value="@mUOMAux.UomCode">@mUOMAux.UomName</option>
                                    }
                                }
                            </datalist>
                        </td>
                        <td><input type="number" id='@mDiscPrcnt' class="form-control" value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Percent, (item.DiscPrcnt != null ? item.DiscPrcnt.Value : 0)))' onchange="LineWasChanged('@item.LineNum');ChangeValue('@item.LineNum',true);" title="type &quot;a&quot;"></td>
                        <td id='@mPriceDisc'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, item.Price))</td>

                        <td><input id='@mTaxCode' class="form-control autoComplete" value="@(!string.IsNullOrEmpty(item.TaxCode) ? item.TaxCode : ((Model.LawsSet == "AR") ? (item.TaxCodeAP) : string.Empty))" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td id='@mVatPrcnt'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Percent, (item.VatPrcnt != null ? item.VatPrcnt.Value : 0)))</td>
                        <td id='@mPriceAfVAT'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (item.PriceAfVAT != null ? item.PriceAfVAT.Value : 0)))</td>
                        <td id='@mVatSum'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (item.VatSum != null ? item.VatSum.Value : 0)))</td>
                         @{
                    if (Model.Lines.Count > 0)
                    {
                        if (Model.Lines.FirstOrDefault().MappedUdf != null && Model.Lines.FirstOrDefault().MappedUdf.Count > 0)
                        {
                            foreach (var DictRow in item.MappedUdf.OrderBy(c => c.UDFName))
                            {
                                <td>
                                    @if (DictRow.ListUFD1.Count > 0)
                                    {
                                            @Html.DropDownList(DictRow.UDFName, new SelectList(
                                                 DictRow.ListUFD1,
                                                "FldValue",
                                                 "Descr", DictRow.Value), new { @Id = "LINEUDF_" + DictRow.UDFName + item.LineNum, @Name = "LINEUDF_"+DictRow.UDFName, @class = "form-control UDFField", @onchange = "LineWasChanged('" + item.LineNum + "');" })
                                    }
                                    else
                                    {
                                        <input id='LINEUDF_@DictRow.UDFName@item.LineNum' name="LINEUDF_@DictRow.UDFName" class="form-control UDFField" value='@DictRow.Value' onchange="LineWasChanged('@item.LineNum');" />
                                    }
                                </td>
                            }
                        }
                    }
                        }
                        <td id='@mTdId'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (decimal)mTotal))</td>
                        <td id='@mGTotal'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (item.GTotal != null ? item.GTotal.Value : 0)))</td>
                    </tr>
                    <script type="text/javascript">
                        $("#" + '@mTAuto').autocomplete({
                            source: WhItems
                        });
                        $("#" + '@mTAutoDR').autocomplete({
                            source: DistrRuleItems
                        });
                        $("#" + '@mTAutoGLAccount').autocomplete({
                            source: GLItems
                        });
                        

                        //Tax Code List Autocomplete
                        $("#" + '@mTaxCode').autocomplete({

                            minLength: 1,
                            source: function (request, response) {
                                $.ajax({
                                    url: '/Purchase/PurchaseOrder/GetTaxCodeList',
                                    type: 'POST',
                                    async: true,
                                    dataType: 'json',
                                    success: function (data) {
                                        var mTaxCodeList = [];

                                        $.each(data, function (key) {

                                            mTaxCodeList.push({
                                                value: data[key].Code,
                                                label: data[key].Name,
                                                rateval: data[key].Rate
                                            });

                                        });
                                        response(mTaxCodeList);

                                    }, error: function (xhr) {
                                        ErrorCalls(xhr.status)

                                    },
                                });

                            },
                            select: function (event, ui) {
                                $("#" + '@mVatPrcnt').html(ui.item.rateval);
                                ChangeValue('@item.LineNum',true);
                            }
                        });
                    </script>
                }
            }
        </tbody>
    </table>
</div>
<script type="text/javascript">

    $("#RightLateralMessageContent").html("@PurchaseOrders.IWACTTO");

    function GetStock(item) {

        $.ajax({
            url: '/Purchase/PurchaseOrder/GetItemStock',
            contextType: 'application/html;charset=utf-8',
            data: { ItemCode: item },
            async: true,
            type: 'POST',
            dataType: 'html'
        }).done(function (data) {

            alertify.alert(data);

        });


    }

    $(document).ready(function () {
        $('.input-group.date').datepicker({});
        var mRead = '@ViewBag.CalculateRate';

        if (mRead == "Y") {
            CalculateTaxForAllLine();
        }

    });

    function CalculateTaxForAllLine() {
        var mIntRow = 0;
        $("#TableItemsForm :input[type=hidden]").each(function () {
            mIntRow++;
            var input = $(this);
            var mLineId = input.attr('id');
            ChangeValue(mLineId, false);
        });

        if (mIntRow > 0) {
            $('#alertItems').hide();
            CalculatedTotal();
        }
        else {
            $("#TotalDoc").val(0);
            $("#TotalDocPD").val($("#TotalExpns").val());
            $("#DiscPrcnt").val(0);
            $("#TotalDisc").val(0);

        }
    }

</script>
